=== contrib/libosmocore/debian/control ===
Source: libosmocore
Section: libs
Priority: optional
Maintainer: Harald Welte <laforge@gnumonks.org>
Build-Depends: debhelper (>= 9), autotools-dev, autoconf, automake, libtool, dh-autoreconf, libdpkg-perl, git, doxygen, libpcsclite-dev, pkg-config
Standards-Version: 3.9.6
Homepage: http://bb.osmocom.org/trac/wiki/libosmocore
Vcs-Git: git://git.osmocom.org/libosmocore.git
Vcs-Browser: http://git.osmocom.org/gitweb?p=libosmocore.git;a=summary

Package: libosmocore
Section: libs
Architecture: any
Depends: libosmocodec0, libosmocore6, libosmogb3, libosmogsm5, libosmovty1, ${misc:Depends}
Multi-Arch: foreign
Description: Open Source MObile COMmunications CORE library

Package: libosmocodec0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo codec library

Package: libosmocore6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo Core library

Package: libosmogb3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo GPRS GB library

Package: libosmogsm5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo GSM utility library

Package: libosmovty1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo VTY library

Package: libosmoctrl0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo control library

Package: libosmosim0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo SIM library

Package: libosmocore-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libosmocore
Multi-Arch: same
Description: Development headers for Open Source MObile COMmunications CORE library

Package: libosmocore-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libosmocore
Multi-Arch: same
Description: Utilities for gsm

Package: libosmocore-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libosmocore (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Debug symbols for Open Source MObile COMmunications CORE library
